//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "afxinet.h"
#include "emule.h"
#include "emuleDlg.h"
#ifdef OLD_SOCKETS_ENABLED
#include "sockets.h"
#endif //OLD_SOCKETS_ENABLED
#include "KnownFileList.h"
#include "KnownFile.h"
#include "ServerList.h"
#include "opcodes.h"
#include "SharedFileList.h"
#include "ED2KLink.h"
#include "math.h"
#include "SplashScreen.h"
#pragma comment(lib, "winmm.lib")
#include "Mmsystem.h"
#include "EnBitmap.h"
#include "HTRichEditCtrl.h"
#include <comdef.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const static UINT		UWM_ARE_YOU_EMULE = RegisterWindowMessage(_T(EMULE_GUID));

BEGIN_MESSAGE_MAP(CEmuleDlg, CTrayDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_CLOSE()

	ON_NOTIFY_EX_RANGE(UDM_TOOLTIP_DISPLAY,0,0xFFFF,OnToolTipNotify)

	ON_COMMAND(MP_CONNECT, StartConnection)
	ON_COMMAND(MP_DISCONNECT, CloseConnection)
	ON_COMMAND(MP_RESTORE, RestoreWindow)
	ON_COMMAND(MP_EXIT, OnClose )

	ON_MESSAGE(WM_TASKBARNOTIFIERCLICKED, OnTaskbarNotifierClicked)
	ON_MESSAGE(WM_COPYDATA, OnWMData)
	ON_MESSAGE(TM_FINISHEDHASHING, OnFileHashed)
	ON_MESSAGE(TM_HASHFAILED, OnHashFailed)
	ON_MESSAGE(WEB_CONNECT_TO_SERVER, OnWebServerConnect)
	ON_MESSAGE(WEB_REMOVE_SERVER, OnWebServerRemove)
	ON_MESSAGE(WEB_ADD_TO_STATIC, OnWebServerAddToStatic)
	ON_MESSAGE(WEB_REMOVE_FROM_STATIC, OnWebServerRemoveFromStatic)
	ON_MESSAGE(WEB_CLEAR_COMPLETED, OnWebServerClearCompleted)
	ON_MESSAGE(WEB_FILE_RENAME, OnWebServerFileRename)
	ON_MESSAGE(WEB_SHARED_FILES_RELOAD, OnWebSharedFilesReload)
	ON_REGISTERED_MESSAGE(UWM_ARE_YOU_EMULE, OnAreYouEmule)

	ON_WM_QUERYENDSESSION()
	ON_WM_TIMER()
	ON_WM_NCDESTROY()
	ON_WM_ACTIVATE()
END_MESSAGE_MAP()

//Lucas - 08-Jan Define settig the Timer ID to be used.
//Could be interesting to standarize the TIMER_IDs (there are many already)
#define INIT_TIMER_ID 1234 // This is a magic number...

// CEmuleDlg Dialog

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CEmuleDlg::CEmuleDlg(CWnd* pParent /*=NULL*/)
	: CTrayDialog(CEmuleDlg::IDD, pParent)
{
	static const uint16 s_auClientIconResID[] =
	{
		IDI_COMPROT,		//SO_PLUS
		IDI_COMPROT,		//SO_EMULE
		IDI_AMULE,			//SO_AMULE
		IDI_EDONKEYHYBRID,	//SO_EDONKEYHYBRID
		IDI_NORMAL,			//SO_EDONKEY
		IDI_MLDONKEY,		//SO_MLDONKEY
		IDI_SECUREHASH,		//SO_OLDEMULE + non-SUI
		IDI_SHAREAZA,		//SO_SHAREAZA
		IDI_XMULE,			//SO_XMULE
		IDI_LPHANT,			//SO_LPHANT
		IDI_UNKNOWN			//SO_UNKNOWN
	};
	static const uint16 s_auPropIconResID[] =
	{
		IDI_FRIEND_ONLY,			//CLIENT_IMGLST_FRIEND
		IDI_CREDIT_ONLY,			//CLIENT_IMGLST_CREDITUP
		IDI_CREDIT_DOWNESTIMATED,	//CLIENT_IMGLST_CREDITDOWN
		IDI_BANNED_ONLY				//CLIENT_IMGLST_BANNED
	};

	EMULE_TRY

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hiconMyTray = NULL;
	m_bStartUpMinimized = false;

	m_pstrNewLogTextLines = new CString;
	m_pstrNewDebugLogTextLines = new CString;

	lastuprate = 0;
	lastdownrate = 0;
	g_eMuleApp.m_app_state = g_eMuleApp.APP_STATE_RUNNING;
	m_iStatus = 0;

	HINSTANCE hInst = AfxGetInstanceHandle();

	m_hiconConn = NULL;
	m_hiconTrans[0] = (HICON)::LoadImage(hInst, MAKEINTRESOURCE(IDI_UP0),IMAGE_ICON,16,16,0);
	m_hiconTrans[1] = (HICON)::LoadImage(hInst, MAKEINTRESOURCE(IDI_UP1),IMAGE_ICON,16,16,0);
	m_hiconTrans[2] = (HICON)::LoadImage(hInst, MAKEINTRESOURCE(IDI_DOWN0),IMAGE_ICON,16,16,0);
	m_hiconTrans[3] = (HICON)::LoadImage(hInst, MAKEINTRESOURCE(IDI_DOWN1),IMAGE_ICON,16,16,0);
	m_hiconIM[0] = 0;
	m_hiconIM[1] = (HICON)::LoadImage(hInst, MAKEINTRESOURCE(IDI_MESSAGE),IMAGE_ICON,16,16,0);
	m_hiconIM[2] = (HICON)::LoadImage(hInst, MAKEINTRESOURCE(IDI_MPENDING),IMAGE_ICON,16,16,0);
	m_hiconSourceTray = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_TRAYICON),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	m_hiconSourceTrayLowID = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_TRAYICON_LOWID),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	m_hiconSourceTrayGrey = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_TRAYICON_GREY),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	m_hiconUsers = (HICON)::LoadImage(hInst, MAKEINTRESOURCE(IDI_USERS),IMAGE_ICON,16,16,0);
	m_pSystrayDlg = NULL;

	m_strDebugLogFilePath.Format(_T("%sdebug.log"), g_eMuleApp.m_pGlobPrefs->GetAppDir());
	m_strLogFilePath.Format(_T("%seMule.log"), g_eMuleApp.m_pGlobPrefs->GetAppDir());

// Prepare image lists with 16x16 client icons
	CImageList	m_tmpImageList;

//	Load plain client icons
	m_clientImgLists[CLIENT_IMGLST_PLAIN].Create(16, 16, g_eMuleApp.m_iDfltImageListColorFlags | ILC_MASK, ELEMENT_COUNT(s_auClientIconResID), 0);
	m_clientImgLists[CLIENT_IMGLST_PLAIN].SetBkColor(CLR_NONE);
	FillImgLstWith16x16Icons(&m_clientImgLists[CLIENT_IMGLST_PLAIN], s_auClientIconResID, ELEMENT_COUNT(s_auClientIconResID));

//	Create client icons with different properties
	m_tmpImageList.Create(16, 16, g_eMuleApp.m_iDfltImageListColorFlags | ILC_MASK, 1, 0);
	m_tmpImageList.SetImageCount(1);
	for (unsigned uiListIdx = 1; uiListIdx <= ELEMENT_COUNT(s_auPropIconResID); uiListIdx++)
	{
		HICON	hIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(s_auPropIconResID[uiListIdx - 1]), IMAGE_ICON, 0, 0, 0));

		m_tmpImageList.Replace(0, hIcon);
		::DestroyIcon(hIcon);

		m_clientImgLists[uiListIdx].Create(16, 16, g_eMuleApp.m_iDfltImageListColorFlags | ILC_MASK, ELEMENT_COUNT(s_auClientIconResID), 0);
		m_clientImgLists[uiListIdx].SetBkColor(CLR_NONE);
		for (unsigned uiIdx = 0; uiIdx < ELEMENT_COUNT(s_auClientIconResID); uiIdx++)
		{
			HIMAGELIST hImgLst = ::ImageList_Merge(m_clientImgLists[CLIENT_IMGLST_PLAIN].m_hImageList, uiIdx, m_tmpImageList.m_hImageList, 0, 0, 0);

			hIcon = ::ImageList_GetIcon(hImgLst, 0, 0);
			m_clientImgLists[uiListIdx].Add(hIcon);
			::DestroyIcon(hIcon);
			::ImageList_Destroy(hImgLst);
		}
	}

#ifdef NEW_SOCKETS
//	m_pEngineData = new CEngineData(*g_eMuleApp.m_pEngine);
#endif //NEW_SOCKETS

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CEmuleDlg::~CEmuleDlg()
{
	EMULE_TRY

	if (m_hiconMyTray != NULL)
		DestroyIcon(m_hiconMyTray);

	::DestroyIcon(m_hIcon);
	if (m_hiconConn != NULL)
		::DestroyIcon(m_hiconConn);
	::DestroyIcon(m_hiconTrans[0]);
	::DestroyIcon(m_hiconTrans[1]);
	::DestroyIcon(m_hiconTrans[2]);
	::DestroyIcon(m_hiconTrans[3]);
	::DestroyIcon(m_hiconIM[1]);
	::DestroyIcon(m_hiconIM[2]);
	::DestroyIcon(m_hiconSourceTray);
	::DestroyIcon(m_hiconSourceTrayLowID);
	::DestroyIcon(m_hiconSourceTrayGrey);
	::DestroyIcon(m_hiconUsers);

	m_wndServer.DestroyWindow();
	m_wndSharedFiles.DestroyWindow();
	m_dlgSearch.DestroyWindow();
	m_wndChat.DestroyWindow();
	m_wndTransfer.DestroyWindow();
	m_dlgStatistics.DestroyWindow();
	m_wndIRC.DestroyWindow();

	if (m_pstrNewLogTextLines)
		delete m_pstrNewLogTextLines;
	if (m_pstrNewDebugLogTextLines)
		delete m_pstrNewDebugLogTextLines;

#ifdef NEW_SOCKETS
//	if (m_pEngineData)
//		delete m_pEngineData;
#endif //NEW_SOCKETS

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::DoDataExchange(CDataExchange *pDX)
{
	CTrayDialog::DoDataExchange(pDX);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnAreYouEmule(WPARAM, LPARAM)
{
	return UWM_ARE_YOU_EMULE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
DWORD WINAPI CheckCurrentVersionAtInet(void *)
{
	EMULE_TRY

	CString strUrl;
	BOOL bNTBased = FALSE;
	WORD wWinVer = DetectWinVersion(bNTBased);
	strUrl.Format(
		_T("http://emuleplus.servehttp.com/get_version.php?version=%i&language=%i&os=%i&nt=%i&webserver=%i&lancast=%i&mobilemule=%i&cpu=%i"),
		CURRENT_PLUS_VERSION,
		g_eMuleApp.m_pGlobPrefs->GetLanguageID(),
		wWinVer, bNTBased,
		g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled(),
		g_eMuleApp.m_pGlobPrefs->GetLancastEnabled(),
		g_eMuleApp.m_pGlobPrefs->IsMMServerEnabled(),
		(int)get_cpu_type());

	bool bDone = false;
	HINTERNET hOpen = InternetOpen(_T("eMule"), INTERNET_OPEN_TYPE_PRECONFIG , NULL, NULL, 0);
	if(hOpen)
	{
		HINTERNET hURL = InternetOpenUrl(hOpen, strUrl, _T(""), NULL, INTERNET_FLAG_NO_CACHE_WRITE, NULL);
		if (hURL)
		{
			TCHAR pBuf[2000];
			DWORD dwSize;
			if(InternetReadFile(hURL, pBuf, 1000, &dwSize))
			{
				pBuf[dwSize] = 0;
				// utf8? convert!
				if(pBuf[0] == (TCHAR)0xEF && pBuf[1] == (TCHAR)0xBB && pBuf[2] == (TCHAR)0xBF)
				{
					WCHAR pNewBuf[2000];
					int iBytes;
					if(iBytes = MultiByteToWideChar(CP_UTF8, 0, pBuf, dwSize, pNewBuf, 1000))
					{
						pNewBuf[iBytes] = 0; dwSize = iBytes;
						_tcscpy(pBuf, (TCHAR*)(_bstr_t(pNewBuf+1)));
					}
				}
				if(pBuf[0] == 'O' && pBuf[1] == 'K') // everything allright
				{
					CString strOut(pBuf + 2);
					g_eMuleApp.m_pdlgEmule->AddLogLine(true, RGB_LOG_NOTICE + strOut);
					g_eMuleApp.m_pdlgEmule->AddDebugLogLine(
						RGB_LOG_NOTICE + _T("Anonymous statistical data sent to eMule Plus home site: Version=%i Language=%i OS=%i NT=%i Webserver=%i Lancast=%i MobileMule=%i CPU=%i"),
						CURRENT_PLUS_VERSION,
						g_eMuleApp.m_pGlobPrefs->GetLanguageID(),
						wWinVer, bNTBased,
						g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled(),
						g_eMuleApp.m_pGlobPrefs->GetLancastEnabled(),
						g_eMuleApp.m_pGlobPrefs->IsMMServerEnabled(),
						(int)get_cpu_type());
					g_eMuleApp.m_pGlobPrefs->SetAutoCheckLastTime(time(NULL));
					bDone = true;
				}
			}
		}
	}
//	if(!bDone)
//		maybe add log line "couldn't check latest version"?


	EMULE_CATCH2

	return 0;
}
*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
DWORD WINAPI CheckCurrentVersionAtInet(void *)
{
	EMULE_TRY

	CString strUrl;
	BOOL bNTBased = FALSE;

	strUrl.Format( _T("http://plus.go.dyndns.org/get_version.php?version=%i&language=%i"),
				   CURRENT_PLUS_VERSION, g_eMuleApp.m_pGlobPrefs->GetLanguageID() );

	bool bDone = false;
	HINTERNET hOpen = InternetOpen(_T("eMule"), INTERNET_OPEN_TYPE_PRECONFIG , NULL, NULL, 0);
	if(hOpen)
	{
		HINTERNET hURL = InternetOpenUrl(hOpen, strUrl, _T(""), NULL, INTERNET_FLAG_NO_CACHE_WRITE, NULL);
		if (hURL)
		{
			TCHAR pBuf[2000];
			DWORD dwSize;
			if(InternetReadFile(hURL, pBuf, 1000, &dwSize))
			{
				pBuf[dwSize] = 0;
			//	UTF8? Convert!
				if(pBuf[0] == (TCHAR)0xEF && pBuf[1] == (TCHAR)0xBB && pBuf[2] == (TCHAR)0xBF)
				{
					WCHAR pNewBuf[2000];
					int iBytes;
					if(iBytes = MultiByteToWideChar(CP_UTF8, 0, pBuf, dwSize, pNewBuf, 1000))
					{
						pNewBuf[iBytes] = 0; dwSize = iBytes;
						_tcscpy(pBuf, (TCHAR*)(_bstr_t(pNewBuf+1)));
					}
				}
			// 	Everything alright
				if(pBuf[0] == 'O' && pBuf[1] == 'K')
				{
					CString strOut(pBuf + 2);
					g_eMuleApp.m_pdlgEmule->AddLogLine(true, RGB_LOG_NOTICE + strOut);
					if (strOut.Find(_T("http://emuleplus.info")) != -1)
					{
						g_eMuleApp.m_pdlgEmule->ShowNotifier(strOut, TBN_LOG, false, true);
					}
					g_eMuleApp.m_pGlobPrefs->SetAutoCheckLastTime(time(NULL));
					bDone = true;
				}
			}
		}
	}

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::OnInitDialog()
{
	EMULE_TRY

	CTrayDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu	*pSysMenu = GetSystemMenu(FALSE);

	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, GetResString(IDS_ABOUTBOX));
	}

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

//	Set font
	m_fontDefault.CreatePointFont(g_eMuleApp.m_pGlobPrefs->GetFontSize(),g_eMuleApp.m_pGlobPrefs->GetUsedFont());

//	Set tool bar
	m_ctlToolBar.Create(WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, CRect(0,0,0,0), this, IDC_TOOLBAR);
	m_ctlToolBar.Init();
	m_ctlToolBar.ShowSpeedMeter(g_eMuleApp.m_pGlobPrefs->GetShowToolbarSpeedMeter());

	uint32	dwMaxRange = g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate();

	if (g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate() > dwMaxRange)
		dwMaxRange = g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate();
	m_ctlToolBar.SetSpeedMeterRange(dwMaxRange / 10, 0);

#ifdef USE_REBAR
//	Set rebar
	REBARBANDINFO	rbbi;
	CSize			sizeBar;

	m_ctlToolBar.GetMaxSize(&sizeBar);
	m_ctlReBar.Create( WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_BORDER | RBS_BANDBORDERS
					 | /*RBS_AUTOSIZE |*/ RBS_VARHEIGHT | CCS_NODIVIDER | CCS_TOP,
					   CRect(0, 0, 0, 0),
					   this,
					   AFX_IDW_REBAR);

//	Insert the tool bar into the rebar
	rbbi.cbSize       = sizeof(REBARBANDINFO);
	rbbi.fMask        = RBBIM_SIZE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE;
	rbbi.cxMinChild   = 0;
	rbbi.cyMinChild   = sizeBar.cy;
	rbbi.cx           = 0;
	rbbi.fStyle       = RBBS_NOGRIPPER | RBBS_BREAK;
	rbbi.hwndChild    = (HWND) m_ctlToolBar;
	m_ctlReBar.InsertBand(-1, &rbbi);
#endif

//	Set window title
	SetWindowText(CLIENT_NAME_WITH_VER);

//	Initialize Taskbar Notifier
	m_wndTaskbarNotifier.Create(this);

	CEnBitmap		m_imgTaskbar;

	VERIFY(m_imgTaskbar.LoadImage(IDR_POPUP,_T("JPG")));
	m_wndTaskbarNotifier.SetBitmap(&m_imgTaskbar, 255, 0, 255);
	m_wndTaskbarNotifier.SetTextFont(_T("Arial"),g_eMuleApp.m_pGlobPrefs->NotificationFontSize(),TN_TEXT_NORMAL,TN_TEXT_UNDERLINE);
	m_wndTaskbarNotifier.SetTextColor(RGB(255,255,230),RGB(255,255,255));
	m_wndTaskbarNotifier.SetTextRect(CRect(14,40,m_wndTaskbarNotifier.m_nBitmapWidth-14,m_wndTaskbarNotifier.m_nBitmapHeight-14));
	m_wndTaskbarNotifier.m_bStarted = true;

// 	Set m_ctlStatusBar
	m_ctlStatusBar.Create(WS_CHILD|WS_VISIBLE|CCS_BOTTOM|SBARS_SIZEGRIP,CRect(0,0,0,0), this, IDC_STATUSBAR);
	ResizeStatusBar();
	m_ctlStatusBar.SetIcon(SB_NUMUSERS, m_hiconUsers);

// 	Create dialog pages
	m_dlgPreferences.SetPrefs(g_eMuleApp.m_pGlobPrefs);
	m_wndServer.Create(IDD_SERVER);
	m_wndSharedFiles.Create(IDD_FILES);
	m_dlgSearch.Create(IDD_SEARCH);
	m_wndChat.Create(IDD_CHAT);
	m_wndTransfer.Create(IDD_TRANSFER);
	m_dlgStatistics.Create(IDD_STATISTICS);
	m_wndIRC.Create(IDD_IRC);
	m_pdlgActive = &m_wndTransfer;

	CRect rClientRect;
	GetClientRect(&rClientRect);
#ifdef USE_REBAR
	CRect rReBarRect;
	m_ctlReBar.GetWindowRect(&rReBarRect);
	CRect rStatusbarRect;
	m_ctlStatusBar.GetWindowRect(&rStatusbarRect);
	rClientRect.top += rReBarRect.Height();
	rClientRect.bottom -= rStatusbarRect.Height();
#else
	CRect rToolbarRect;
	m_ctlToolBar.GetWindowRect(&rToolbarRect);
	CRect rStatusbarRect;
	m_ctlStatusBar.GetWindowRect(&rStatusbarRect);
	rClientRect.top += rToolbarRect.Height();
	rClientRect.bottom -= rStatusbarRect.Height();
#endif
	m_wndServer.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndTransfer.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndSharedFiles.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_dlgSearch.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndChat.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndIRC.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_dlgStatistics.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);

// 	Load connection state icon
	ShowConnectionState(false, _T(""), true);

// 	Anchors
	AddAnchor(m_wndServer,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndTransfer,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndSharedFiles,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_dlgSearch,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndChat,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndIRC,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_ctlStatusBar,BOTTOM_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_dlgStatistics,TOP_LEFT,BOTTOM_RIGHT);
#ifdef USE_REBAR
	AddAnchor(m_ctlReBar,TOP_LEFT, TOP_RIGHT);
#else
	AddAnchor(m_ctlToolBar,TOP_LEFT, TOP_RIGHT);
#endif

	m_dlgStatistics.ShowInterval();

//	Set Tray icon
	TraySetMinimizeToTray(g_eMuleApp.m_pGlobPrefs->GetMinTrayPTR());
	TrayMinimizeToTrayChanged();

//	Update Categories
	m_dlgSearch.UpdateCatTabs();

	m_wndServer.ShowWindow(SW_SHOW);
	m_pdlgActive = &m_wndServer;

	g_eMuleApp.m_pGlobPrefs->SetSmartIdState(1);

//	Restore saved window placement
	WINDOWPLACEMENT wp;wp.length=sizeof(wp);
	wp=g_eMuleApp.m_pGlobPrefs->GetEmuleWindowPlacement();
	SetWindowPlacement(&wp);

	Localize();

	m_ttip.Create(this); 
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 15000); 
	m_ttip.SetDelayTime(TTDT_INITIAL, g_eMuleApp.m_pGlobPrefs->GetToolTipDelay()*1000);
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); 
	m_ttip.SetBehaviour(PPTOOLTIP_MULTIPLE_SHOW); 
	m_ttip.SetNotify(m_hWnd);
	m_ttip.AddTool(&m_ctlStatusBar, _T("")); 

#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pMMServer->Init();
#endif //OLD_SOCKETS_ENABLED

//	SplashScreen
	if (g_eMuleApp.m_pGlobPrefs->UseSplashScreen() && !g_eMuleApp.m_pGlobPrefs->GetStartMinimized())
	{
		CSplashScreen splash(this);
		splash.DoModal();
	}

	if (!SetTimer(INIT_TIMER_ID,300,NULL))
		AfxMessageBox(GetResString(IDS_ERR_FAILEDTIMER));

//	Set proper Scheduler Shift if option is set
	if (g_eMuleApp.m_pGlobPrefs->IsSCHEnabled())
	{
		CTime curr_t = CTime::GetCurrentTime();
		uint32 secs = curr_t.GetSecond() + 60*curr_t.GetMinute() + 60*60*curr_t.GetHour();
		bool bShift1;

		if (g_eMuleApp.m_pGlobPrefs->GetSCHShift1() > g_eMuleApp.m_pGlobPrefs->GetSCHShift2())
		{
			if (secs > g_eMuleApp.m_pGlobPrefs->GetSCHShift1())
				bShift1 = true;
			else if (secs < g_eMuleApp.m_pGlobPrefs->GetSCHShift2())
				bShift1 = true;
			else
				bShift1 = false;
		}
		else
		{
			if (secs > g_eMuleApp.m_pGlobPrefs->GetSCHShift1() && secs < g_eMuleApp.m_pGlobPrefs->GetSCHShift2())
				bShift1 = true;
			else
				bShift1 = false;
		}

		if(bShift1)
		{
		//	Switching to Shift1 speeds
			g_eMuleApp.m_pUploadQueue->SCHShift1UploadCheck();
			g_eMuleApp.m_pGlobPrefs->SetMaxUpload(g_eMuleApp.m_pGlobPrefs->GetSCHShift1Upload());
			g_eMuleApp.m_pGlobPrefs->SetMaxDownload(g_eMuleApp.m_pGlobPrefs->GetSCHShift1Download());
			g_eMuleApp.m_pGlobPrefs->SetMaxConnections(g_eMuleApp.m_pGlobPrefs->GetSCHShift1conn());
			g_eMuleApp.m_pGlobPrefs->SetMaxDownloadConperFive(g_eMuleApp.m_pGlobPrefs->GetSCHShift15sec());

			CString MessageText;
			MessageText.Format( _T("SCHEDULER: switching to Shift 1 (Max Upload:%.1f Max Download:%.1f Max Connections:%i Max In 5 secs:%i)"),
								static_cast<double>(g_eMuleApp.m_pGlobPrefs->GetSCHShift1Upload()) / 10.0,
								static_cast<double>(g_eMuleApp.m_pGlobPrefs->GetSCHShift1Download()) / 10.0,
								g_eMuleApp.m_pGlobPrefs->GetSCHShift1conn(),
								g_eMuleApp.m_pGlobPrefs->GetSCHShift15sec() );
			g_eMuleApp.AddDebugLogLine(MessageText);
		}
		else
		{
            int dayOfWeek = curr_t.GetDayOfWeek();

			if ((dayOfWeek==2 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptMon())
				|| (dayOfWeek==3 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptTue())
				|| (dayOfWeek==4 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptWed())
				|| (dayOfWeek==5 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptThu())
				|| (dayOfWeek==6 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptFri())
				|| (dayOfWeek==7 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptSat())
				|| (dayOfWeek==1 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptSun()))
           	{
               	g_eMuleApp.AddDebugLogLine(_T("SCHEDULER: day excepted!"));
			}
			else
			{
			//	Switching to Shift2 speeds
				g_eMuleApp.m_pUploadQueue->SCHShift2UploadCheck();
				g_eMuleApp.m_pGlobPrefs->SetMaxUpload(g_eMuleApp.m_pGlobPrefs->GetSCHShift2Upload());
				g_eMuleApp.m_pGlobPrefs->SetMaxDownload(g_eMuleApp.m_pGlobPrefs->GetSCHShift2Download());
				g_eMuleApp.m_pGlobPrefs->SetMaxConnections(g_eMuleApp.m_pGlobPrefs->GetSCHShift2conn());
				g_eMuleApp.m_pGlobPrefs->SetMaxDownloadConperFive(g_eMuleApp.m_pGlobPrefs->GetSCHShift25sec());

				CString MessageText;
				MessageText.Format( _T("SCHEDULER: switching to Shift 2 (Max Upload:%.1f Max Download:%.1f Max Connections:%i Max In 5 secs:%i)"),
									static_cast<double>(g_eMuleApp.m_pGlobPrefs->GetSCHShift2Upload()) / 10.0,
									static_cast<double>(g_eMuleApp.m_pGlobPrefs->GetSCHShift2Download()) / 10.0,
									g_eMuleApp.m_pGlobPrefs->GetSCHShift2conn(),
									g_eMuleApp.m_pGlobPrefs->GetSCHShift25sec() );
				g_eMuleApp.AddDebugLogLine(MessageText);
			}
		}
	}

	return TRUE;

	EMULE_CATCH2

	return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnTimer(UINT_PTR nIDEvent)
{
	EMULE_TRY

	if (nIDEvent == INIT_TIMER_ID)
	{
		switch (m_iStatus)
		{
			case 0:	// State 0 - 300ms after InitDialog()
				m_iStatus++;
				g_eMuleApp.m_pSharedFilesList->SetOutputCtrl(&m_wndSharedFiles.m_ctlSharedFilesList);
				break;

			case 1:	// State 1 - 300ms after the end of State 0
				m_iStatus++;
				g_eMuleApp.m_pServerList->Init();
				break;

			case 2:	// State 2 - 300ms after the server list is init'ed.
				KillTimer(nIDEvent);
				m_iStatus++;
			//	Read in all the .met files and make them available for sharing
				g_eMuleApp.m_pDownloadQueue->Init();
				g_eMuleApp.m_pFakeCheck->Init();
#ifdef OLD_SOCKETS_ENABLED
				if (!g_eMuleApp.m_pListenSocket->StartListening())
					AddLogLine(false, RGB_LOG_ERROR + GetResString(IDS_MAIN_SOCKETERROR), g_eMuleApp.m_pGlobPrefs->GetPort());
				if (!g_eMuleApp.m_pClientUDPSocket->Create())
			   		AddLogLine(false, RGB_LOG_ERROR + GetResString(IDS_MAIN_SOCKETERROR), g_eMuleApp.m_pGlobPrefs->GetUDPPort());
#endif //OLD_SOCKETS_ENABLED

			//	Display own userhash
				AddLogLine(false, _T("%s: %s"), GetResString(IDS_INFLST_USER_USERHASH), HashToString(g_eMuleApp.m_pGlobPrefs->GetUserHash()));

			//	Display eMule Plus version
				AddLogLine(true, IDS_MAIN_READY, CURRENT_VERSION_LONG);

			//	Display used optimization
				UINT		dwResStrId;

				switch (get_cpu_type())
				{
					case 1:
						dwResStrId = IDS_OPTIMIZATION_NO;
						break;
					case 2:
						dwResStrId = IDS_OPTIMIZATION_MMX;
						break;
					case 3:
						dwResStrId = IDS_OPTIMIZATION_AMD;
						break;
					case 4:
					case 5:
						dwResStrId = IDS_OPTIMIZATION_SSE;
						break;
				}
				AddLogLine(false, GetResString(dwResStrId));

			//	Start server anyway, but you'll get response		//	WHY do we do that ??
			//	only if it's enabled in preferences.
				g_eMuleApp.m_pWebServer->StartServer();

			//	Process ed2k link
				if (g_eMuleApp.m_pstrPendingLink)
				{
					OnWMData(NULL,(LPARAM) &g_eMuleApp.m_sendStruct);
					delete g_eMuleApp.m_pstrPendingLink;
				}

			//	Connect to server
				if (g_eMuleApp.m_pGlobPrefs->DoAutoConnect() && !g_eMuleApp.m_pGlobPrefs->AutoServerlist())
					OnBnClickedButton2();

			//	Get current version from internet, if one week elapsed
			//  Don't put lower elapse value, we don't need DDoS attacks! ;)
			//	(later move this to new engine)
				if(g_eMuleApp.m_pGlobPrefs->IsAutoCheckForNewVersion() &&
					(time(NULL) - g_eMuleApp.m_pGlobPrefs->GetAutoCheckLastTime()) > 7*24*60*60)
				{
					DWORD dwThread = 0;
					HANDLE hThread = CreateThread(NULL, 0, CheckCurrentVersionAtInet, (void *)NULL, 0, &dwThread);
					if (hThread)
						VERIFY(CloseHandle(hThread));
				}

			//	Start one second timer to update session time
				if (SetTimer(INIT_TIMER_ID, 1000, NULL) == 0)
					AfxMessageBox(GetResString(IDS_ERR_FAILEDTIMER));
				break;

			case 3:	// State 3 - 1sec after connect
			//	Show the session time in the status bar once a second.
				ShowSessionTime();
				break;

			default:
				AddDebugLogLine(_T("Timer called with no reason"));
		}
	}
	CTrayDialog::OnTimer(nIDEvent);

	EMULE_CATCH2
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
void CEmuleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	EMULE_TRY

	switch(nID & 0xFFF0)
	{
		case IDM_ABOUTBOX:
		{
			CAboutDlg		dlgAbout;

			dlgAbout.DoModal();
			break;
		}
		case SC_CLOSE:
			if(g_eMuleApp.m_pGlobPrefs->GetCloseToTray())
			{
				TrayShow();
				ShowWindow(SW_HIDE);
			}
			else
				CTrayDialog::OnSysCommand(nID, lParam);
			break;
		case SC_MINIMIZE:
		case SC_MINIMIZETRAY:
		case SC_RESTORE:
		case SC_MAXIMIZE:
			CTrayDialog::OnSysCommand(nID, lParam);
			ShowTransferRate(true);
			break;
		default:
			CTrayDialog::OnSysCommand(nID, lParam);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnPaint()
{
	EMULE_TRY

	if (!m_bStartUpMinimized)
	{
		m_bStartUpMinimized=true;

		if (g_eMuleApp.m_pGlobPrefs->GetStartMinimized())
			OnCancel();
	}

	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CTrayDialog::OnPaint();
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
HCURSOR CEmuleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnBnClickedButton2()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pServerConnect->IsConnected())
	{
	// Connect if not currently connected
		if (!g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			if (g_eMuleApp.m_pServerConnect->IsICCActive())
			{
			//	Internet Connection Check is active, cancel it
				g_eMuleApp.m_pServerConnect->Disconnect();
				ShowConnectionState(false);
			}
			else
				StartConnection();
		}
		else
		{
			g_eMuleApp.m_pServerConnect->StopConnectionTry();
			ShowConnectionState(false);
		}
	}
	else
	// Disconnect if currently connected
		CloseConnection();
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OutputLogText(const CString& strLogText, CHTRichEditCtrl* pRichEditCtrl)
{
	EMULE_TRY

	CString		strLine = strLogText, strPart;
	int			iTagStart, iTagEnd, iIndex, iRed, iGreen, iBlue;
	COLORREF	crColor = CLR_DEFAULT, crNewColor;

	while (!strLine.IsEmpty())
	{
		iTagEnd = -1;
		iTagStart = strLine.Find(_T("<COLOR="));
		if (iTagStart > -1)
			iTagEnd = strLine.Find(_T('>'), iTagStart + 7);
		if (iTagEnd > -1)
		{
			crNewColor = -1;
			strPart = strLine.Mid(iTagStart + 7, iTagEnd - iTagStart - 7);
			if (!strPart.IsEmpty())
			{
				if (strPart == _T("Default"))
					crNewColor = CLR_DEFAULT;
				else
				{
					iIndex = strPart.Find(_T(','));
					if (iIndex > -1)
					{
						iRed = _tstoi(strPart.Left(iIndex));
						strPart.Delete(0, iIndex + 1);
						iIndex = strPart.Find(_T(','));
						if (iIndex > -1)
						{
							iGreen = _tstoi(strPart.Left(iIndex));
							strPart.Delete(0, iIndex + 1);
							iBlue = _tstoi(strPart);
							crNewColor = RGB(iRed, iGreen, iBlue);
						}
					}
				}
			}
			if (crNewColor != -1)
			{
				if (iTagStart > 0)
					pRichEditCtrl->AppendText(strLine.Left(iTagStart), crColor);
				crColor = crNewColor;
				strLine.Delete(0, iTagEnd + 1);
			}
		}
		else
		{
			pRichEditCtrl->AppendText(strLine, crColor);
			break;
		}
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::AddLogText(bool addtostatusbar,const CString &strTxt, bool bDebug)
{
	EMULE_TRY

	CString			strLogLine = strTxt;

	strLogLine.Remove(_T('\b'));
	strLogLine.Remove(_T('\r'));
	strLogLine.Remove(_T('\t'));
	strLogLine.Trim();

	if (strLogLine.IsEmpty())
		return;

	CString			strCleanLine = strLogLine;
	int				iTagStart = 0, iTagEnd;

	while (iTagStart != -1)
	{
		iTagStart = strCleanLine.Find(_T("<COLOR="), iTagStart);
		if (iTagStart != -1)
		{
			iTagEnd = strCleanLine.Find(_T('>'), iTagStart + 7);
			if (iTagEnd != -1)
				strCleanLine.Delete(iTagStart, iTagEnd - iTagStart + 1);
			else
				iTagStart++;
		}
	}

	if (addtostatusbar)
	{
		if (m_ctlStatusBar.m_hWnd && g_eMuleApp.m_app_state != CEmuleApp::APP_STATE_SHUTINGDOWN)
			m_ctlStatusBar.SetText(strCleanLine, SB_MESSAGETEXT, 0);
		else
			AfxMessageBox(strCleanLine);
	}
	
	COleDateTime	currentTime(COleDateTime::GetCurrentTime());
	CString			strLogLine2, strTime = currentTime.Format();

	strTime += _T(": ");
	strLogLine2.Format(RGB_DARK_BLUE_TXT _T("%s") RGB_DEFAULT_TXT _T("%s\n"), strTime, strLogLine);

//	Save to file
	if (g_eMuleApp.m_pGlobPrefs->LogToFile())
	{
		FILE	*LogFile = _tfopen((bDebug) ? m_strDebugLogFilePath : m_strLogFilePath, _T("a"));

		if (LogFile != NULL)
		{
			strTime += strCleanLine;
			strTime += _T('\n');
			_fputts(strTime, LogFile);
			fclose(LogFile);
		}
	}
	// 	Only when data save to file output them into GUI
	if (bDebug)
	{
		if (m_pstrNewDebugLogTextLines)
			m_pstrNewDebugLogTextLines->Append(strLogLine2);

	//	post message only if box was created
		if(IsRunning() && ::IsWindow(m_wndServer.m_ctrlBoxSwitcher.m_hWnd))
			PostUniqueMessage(WM_DLOG_REFRESH);
	}
	else
	{
		if (m_pstrNewLogTextLines)
			m_pstrNewLogTextLines->Append(strLogLine2);

	//	post message only if box was created
		if(IsRunning() && ::IsWindow(m_wndServer.m_ctrlBoxSwitcher.m_hWnd))
			PostUniqueMessage(WM_LOG_REFRESH);
		
		ShowNotifier(strCleanLine, TBN_LOG, false, g_eMuleApp.m_pGlobPrefs->GetUseLogNotifier());
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::AddServerMessageLine(LPCTSTR line)
{
	EMULE_TRY

	CString strLine = line;

	strLine.Remove(_T('\b'));
	strLine.Remove(_T('\r'));
	strLine.Remove(_T('\t'));
	strLine.Trim();
	if ((!strLine.IsEmpty()) && (::IsWindow(m_wndServer.m_ctrlBoxSwitcher.m_hWnd)))
	{
		COleDateTime	currentTime(COleDateTime::GetCurrentTime());
		CString			strTime = currentTime.Format();

		strTime += _T(": ");
		m_wndServer.m_pctlServerMsgBox->AppendText(strTime, RGB(0, 0, 128));
		strLine += _T('\n');
		m_wndServer.m_pctlServerMsgBox->AppendText(strLine);
		if (m_wndServer.m_ctrlBoxSwitcher.GetCurSel() != 1)
			m_wndServer.m_ctrlBoxSwitcher.SetItemState(1, TCIS_HIGHLIGHTED, TCIS_HIGHLIGHTED);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::AddBugReport(LPCTSTR strFunctionName, LPCTSTR sFile, long nLine, CString msg)
{
	EMULE_TRY

	if(g_eMuleApp.m_pGlobPrefs->GetBugReport())
	{
		CString sOut;

		sOut.Format(RGB_LOG_ERROR_TXT _T("%s: EXCEPTION! (%s) Report to " CLIENT_NAME " developers. Line %ld in file %s"),
			strFunctionName, msg, nLine, sFile);
		AddDebugLogLine(sOut);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowConnectionState()
{
#ifdef OLD_SOCKETS_ENABLED
	ShowConnectionState(g_eMuleApp.m_pServerConnect->IsConnected(), _T(""));
#endif //OLD_SOCKETS_ENABLED
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowConnectionState(bool bConnected, const CString &strServer /*=""*/, bool bIconOnly /*=false*/)
{
	static const uint16 s_auConnIconResID[] = { IDI_NOTCONNECTED, IDI_CONNECTED, IDI_CONNECTEDHIGH };

	EMULE_TRY

	if(g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_SHUTINGDOWN)
		return;

	CString			strBuff;
	TBBUTTONINFO	tbi;
	int				iIconID;

	tbi.dwMask = TBIF_IMAGE | TBIF_TEXT;
	tbi.cbSize = sizeof(TBBUTTONINFO);
	
	if (bConnected)
	{
		if (!bIconOnly)
		{
			GetResString(&strBuff, IDS_MAIN_CONNECTEDTO);
			strBuff += _T(' ');
			strBuff += strServer;
			m_ctlStatusBar.SetText(strBuff, SB_MESSAGETEXT, 0);
			m_ctlStatusBar.SetText(strServer, SB_SERVER, 0);
		}
		GetResString(&strBuff, IDS_MAIN_BTN_DISCONNECT);
		tbi.iImage = 9;
		tbi.pszText = (LPSTR)strBuff.GetString();
		m_ctlToolBar.SetButtonInfo(IDC_TOOLBARBUTTON + 0, &tbi);
		m_ctlToolBar.AutoSize();

#ifdef OLD_SOCKETS_ENABLED
		iIconID = (g_eMuleApp.m_pServerConnect->IsLowID()) ? 1 : 2;
#endif //OLD_SOCKETS_ENABLED
	}
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			if (!bIconOnly)
			{
				GetResString(&strBuff, IDS_CONNECTING);
				m_ctlStatusBar.SetText(strBuff, SB_SERVER, 0);
			}
			GetResString(&strBuff, IDS_MAIN_BTN_CANCEL);
			tbi.iImage = 10;
		}
		else
		{
			if (!bIconOnly)
			{
				GetResString(&strBuff, IDS_NOTCONNECTED);
				m_ctlStatusBar.SetText(strBuff, SB_SERVER, 0);
				AddLogLine(false, IDS_DISCONNECTED);
			}
			GetResString(&strBuff, IDS_MAIN_BTN_CONNECT);
			tbi.iImage = 0;
		}
		tbi.pszText = (LPSTR)strBuff.GetString();
		m_ctlToolBar.SetButtonInfo(IDC_TOOLBARBUTTON + 0, &tbi);
		iIconID = 0;
		ShowUserCount(0, 0);
#endif //OLD_SOCKETS_ENABLED
	}
	HICON	hPrevIcon = m_hiconConn;

	m_hiconConn = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(s_auConnIconResID[iIconID]), IMAGE_ICON, 16, 16, 0);
	m_ctlStatusBar.SetIcon(SB_SERVER, m_hiconConn);
	if (hPrevIcon != NULL)
		::DestroyIcon(hPrevIcon);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowSessionTime()
{
	uint32		dwRunTimeSecs = static_cast<uint32>((::GetTickCount() - g_eMuleApp.stat_starttime) / 1000);
	CTimeSpan	runTime(static_cast<__time64_t>(dwRunTimeSecs));
	CString		strBuffer;
	unsigned	uiDays, uiHours, uiMinutes;

	uiHours = static_cast<unsigned>(runTime.GetHours());
	uiMinutes = static_cast<unsigned>(runTime.GetMinutes());
	uiDays = static_cast<unsigned>(runTime.GetDays());

	if (uiDays == 0)
	{
		strBuffer.Format("%02u:%02u:%02u", uiHours, uiMinutes, runTime.GetSeconds());
	}
	else
	{
		strBuffer.Format( "%2u %s %02u:%02u", uiDays,
			GetResString((uiDays == 1) ? IDS_LONGDAY : IDS_LONGDAYS), uiHours, uiMinutes );
	}

	m_ctlStatusBar.SetText(strBuffer, SB_SESSIONTIME, 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowUserCount(uint32 users_toshow, uint32 files_toshow)
{
	EMULE_TRY

	if(g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_SHUTINGDOWN)
		return;

	CString sBuffer;
	sBuffer.Format(_T("%u"),users_toshow);
	m_ctlStatusBar.SetText(sBuffer,SB_NUMUSERS,0);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowMessageState(byte iconnr)
{
	EMULE_TRY

	m_ctlStatusBar.SetIcon(SB_MESSAGESTATUS,m_hiconIM[iconnr]);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//v- eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
void CEmuleDlg::ShowTransferRate(bool bUpdateAll)
{
	EMULE_TRY

	CString sBuffer, sUpload, sDownload;

//	More detailed upload speed: 5 sec average instead of 40 sec average (calculated only once)
	double lastuprate_kB = static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRate())/1024.0;
	double lastdownrate_kB = static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate())/1024.0;

	double lastuprateoverhead_kB = static_cast<double>(g_eMuleApp.m_pUploadQueue->GetUpDataRateOverhead())/1024.0;
	double lastdownrateoverhead_kB = static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDownDataRateOverhead())/1024.0;

//	String preparation doesn't depend on output
	if (g_eMuleApp.m_pGlobPrefs->ShowOverhead())
	{
		sBuffer.Format(GetResString(IDS_UPDOWNLONG),lastuprate_kB, lastuprateoverhead_kB, lastdownrate_kB, lastdownrateoverhead_kB);
		sUpload.Format(_T("%.2f (%.2f)"),lastuprate_kB, lastuprateoverhead_kB);
		sDownload.Format(_T("%.2f (%.2f)"),lastdownrate_kB, lastdownrateoverhead_kB);
	}
	else
	{
		sBuffer.Format(GetResString(IDS_UPDOWN),lastuprate_kB, lastdownrate_kB);
		sUpload.Format(_T("%.2f"),lastuprate_kB);
		sDownload.Format(_T("%.2f"),lastdownrate_kB);
	}

//	Set SpeedMeterValues if option is activated
	if(g_eMuleApp.m_pGlobPrefs->GetShowToolbarSpeedMeter())
		m_ctlToolBar.SetSpeedMeterValues((int)lastuprate_kB, (int)lastdownrate_kB);

//	Update window only
	if (IsWindowVisible() || bUpdateAll)
	{
		m_ctlStatusBar.SetText(sUpload,SB_UPLOADRATE,0);
		m_ctlStatusBar.SetText(sDownload,SB_DOWNLOADRATE,0);
		m_ctlStatusBar.SetIcon(SB_UPLOADRATE,m_hiconTrans[(lastuprate_kB)?1:0]);
		m_ctlStatusBar.SetIcon(SB_DOWNLOADRATE,m_hiconTrans[(lastdownrate_kB)?3:2]);

		m_wndTransfer.UpdateDownloadHeader();
		m_wndTransfer.UpdateUploadHeader();
	}

//	Update tray only
	if (TrayIsVisible() || bUpdateAll)
	{
	//	Set trayicon-icon
		int DownRateProcent = (int)ceil(lastdownrate_kB * 1000 / g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate());
		if (DownRateProcent>100) DownRateProcent=100;

		TraySetToolTip(sBuffer);

	//	It's better to do TrayUpdate here, because of TrayToolTip
		UpdateTrayIcon(DownRateProcent);
	}
	if (!TrayIsVisible() && g_eMuleApp.m_pGlobPrefs->ShowRatesOnTitle())
	{
		CString		strTitle;

		strTitle.Format(_T("(U:%.1f D:%.1f) ") CLIENT_NAME_WITH_VER, lastuprate_kB, lastdownrate_kB);
		SetWindowText(strTitle);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnCancel()
{
	EMULE_TRY

	if (*g_eMuleApp.m_pGlobPrefs->GetMinTrayPTR())
	{
		TrayShow();
		ShowWindow(SW_HIDE);
	}
	else
	{
		ShowWindow(SW_MINIMIZE);
	}
	ShowTransferRate();

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnActivate(UINT nState, CWnd *pWndOther, BOOL bMinimized)
{
	CWnd::OnActivate(nState, pWndOther, bMinimized);

//	Update chat and disable taskbar blinking indicator on application activation
	if ((nState != WA_INACTIVE) && (m_pdlgActive == &m_wndChat))
		g_eMuleApp.m_pdlgEmule->m_wndChat.m_ctlChatSelector.ShowChat();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::SetActiveDialog(CDialog* dlg)
{
	EMULE_TRY

	if(dlg == m_pdlgActive)
		return;

	m_pdlgActive->ShowWindow(SW_HIDE);
	dlg->ShowWindow(SW_SHOW);
	dlg->SetFocus();
	m_pdlgActive = dlg;

	if (dlg==&m_wndTransfer)
 	{
		m_wndTransfer.UpdateCatTabTitles();
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+2);
	}
	else if (dlg==&m_wndServer)
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+1);
	else if (dlg==&m_dlgSearch)
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+3);
	else if (dlg==&m_wndSharedFiles)
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+4);
	else if (dlg==&m_wndChat)
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+5);
	else if (dlg==&m_wndIRC)
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+6);
	else if (dlg==&m_dlgStatistics)
	{
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+7);
		m_dlgStatistics.ShowStatistics();
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnSize(UINT nType,int cx,int cy)
{
	EMULE_TRY

	CTrayDialog::OnSize(nType,cx,cy);
	ResizeStatusBar();

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ResizeStatusBar()
{
	CRect rect;
	m_ctlStatusBar.GetClientRect(&rect);

	int		iWidths[SB_NUMSBPARTS] =
	{
		0,105,22,70,70,70,260,
	};

	int		iRightEdges[SB_NUMSBPARTS];

	if (g_eMuleApp.m_pGlobPrefs->ShowOverhead())
	{
		iWidths[SB_UPLOADRATE] = 105;
		iWidths[SB_DOWNLOADRATE] = 105;
		iWidths[SB_SERVER] = 190;
	}

//	Calculate the right edges given the widths
	iRightEdges[SB_NUMSBPARTS-1] = -1;	//Indicates right edge of the status bar
	iRightEdges[SB_NUMSBPARTS-2] = rect.right - iWidths[SB_NUMSBPARTS-1];
	for (int i = SB_NUMSBPARTS-3; i >= 0; i--)
	{
		iRightEdges[i] = iRightEdges[i+1] - iWidths[i+1];
	}
//	Set the status bar part sizes
	m_ctlStatusBar.SetParts(SB_NUMSBPARTS, iRightEdges);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWMData(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	tagCOPYDATASTRUCT* data = (tagCOPYDATASTRUCT*)lParam;
	if (data->dwData == OP_ED2KLINK)
	{
		FlashWindow(true);
		if(g_eMuleApp.m_pGlobPrefs->IsBringToFront())
		{
			if (IsIconic())
			{
				ShowWindow(SW_SHOWNORMAL);
			}
			else if (TrayHide())
			{
				ShowWindow(SW_SHOW);
			}
			else
			{
				SetForegroundWindow();
			}
		}
		try
		{
			CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(URLDecode(CString((char*)data->lpData, data->cbData)));
			_ASSERT( pLink != NULL );
			switch (pLink->GetKind())
			{
				case CED2KLink::kFile:
				{
					CED2KFileLink* pFileLink = pLink->GetFileLink();
					g_eMuleApp.m_pDownloadQueue->AddFileLinkToDownload(pFileLink);

					break;
				}
				case CED2KLink::kServerList:
				{
					CED2KServerListLink* pListLink = pLink->GetServerListLink();
					CString strAddress = pListLink->GetAddress();

					if(strAddress.GetLength() != 0)
						g_eMuleApp.m_pdlgEmule->m_wndServer.UpdateServerMetFromURL(strAddress);

					break;
				}
				case CED2KLink::kServer:
				{
					CString defName;
					CED2KServerLink* pSrvLink = pLink->GetServerLink();
					CServer* pSrv = new CServer(pSrvLink->GetPort(),pSrvLink->GetIP());
					pSrvLink->GetDefaultName(defName);
					pSrv->SetListName(defName.GetBuffer());
					pSrv->SetPreference(PR_HIGH);

					if (!g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.AddServer(pSrv,true))
						delete pSrv;
					else
						AddLogLine(true, GetResString(IDS_SERVERADDED), pSrv->GetListName());

					break;
				}
				default:
					break;
			}
			delete pLink;
		}
		catch(...)
		{
			OUTPUT_DEBUG_TRACE();
			AddLogLine(true, IDS_LINKNOTADDED);
		}
	}
	else if (data->dwData==OP_CLCOMMAND)
	{
	//	Command line command received
		CString clcommand;
		clcommand= (char*)data->lpData;
		clcommand.MakeLower();
		AddLogLine(true, _T("CLI: %s"),clcommand);

		if (clcommand=="connect")
		{
			StartConnection();
			return true;
		}
#ifdef OLD_SOCKETS_ENABLED
		if (clcommand=="disconnect")
		{
			if (g_eMuleApp.m_pServerConnect->IsConnecting())
				g_eMuleApp.m_pServerConnect->StopConnectionTry();
			else
				g_eMuleApp.m_pServerConnect->Disconnect();

			ShowConnectionState(g_eMuleApp.m_pServerConnect->IsConnected(), _T(""), true);
			return true;
		}
#endif //OLD_SOCKETS_ENABLED
		if (clcommand=="resume")
		{
			g_eMuleApp.m_pDownloadQueue->StartNextFile(CCat::GetAllCatType());
			return true;
		}
		if (clcommand=="exit")
		{
			OnClose();
			return true;
		}
		if (clcommand=="reload")
		{
			g_eMuleApp.m_pSharedFilesList->Reload();
			return true;
		}
		if (clcommand=="restore")
		{
			RestoreWindow();
			return true;
		}
		if (clcommand=="preferences")
		{
			g_eMuleApp.m_pGlobPrefs->Save();
			return true;
		}
		if ((clcommand.Left(7) == "limits=") && (clcommand.GetLength() > 8))
		{
			int		iPos = clcommand.Find(':', 7);

			if (iPos >= 7)
			{
				if ((iPos + 1) < clcommand.GetLength())	//	':' isn't last char (download substring isn't empty)
					g_eMuleApp.m_pGlobPrefs->SetMaxDownloadWithCheck(String2FranctionalRate(clcommand.GetString() + iPos + 1));
			}
			if (iPos != 7)	//	upload substring isn't empty
				g_eMuleApp.m_pGlobPrefs->SetMaxUploadWithCheck(String2FranctionalRate(clcommand.GetString() + 7));

			return true;
		}

		if (clcommand == "help" || clcommand == "/?")
		{
		//	Show usage
			return true;
		}

		if (clcommand == "status")
		{
			CString	pString;

		//	TO DO: output to console
			pString.Format(_T("%sstatus.log"),g_eMuleApp.m_pGlobPrefs->GetAppDir());
			FILE* file = _tfopen(pString , _T("w"));

#ifdef OLD_SOCKETS_ENABLED
			if (g_eMuleApp.m_pServerConnect->IsConnected())
				pString = GetResString(IDS_CONNECTED);
			else if (g_eMuleApp.m_pServerConnect->IsConnecting())
				pString = GetResString(IDS_CONNECTING);
			else
				pString = GetResString(IDS_DISCONNECTED);
#else
			pString.Empty();
#endif //OLD_SOCKETS_ENABLED

			pString += _T('\n');
			pString.AppendFormat(GetResString(IDS_UPDOWN), static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRate())/1024.0, static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate())/1024.0);

			_ftprintf(file, _T("%s\n%s"), pString, g_eMuleApp.m_pDownloadList->GetPartFilesStatusString());

			fclose(file);
			return true;
		}
	//	TO DO: show "unknown command"
	}
	return true;

	EMULE_CATCH2

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnFileHashed(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	CKnownFile	   *pNewKnownFile = reinterpret_cast<CKnownFile*>(lParam);

	if (wParam != 0)
	{
		CPartFile	   *pPartFile = reinterpret_cast<CPartFile*>(wParam);

		pPartFile->PartFileHashFinished(pNewKnownFile);
	}
	else
	{
		g_eMuleApp.m_pSharedFilesList->FileHashingFinished(pNewKnownFile);
	}
	return true;

	EMULE_CATCH2;

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnHashFailed(WPARAM wParam, LPARAM lParam)
{
	g_eMuleApp.m_pSharedFilesList->FileHashingFailed(reinterpret_cast<UnknownFile_Struct*>(lParam));
	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnClose()
{
	EMULE_TRY

	if ( (g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_RUNNING) &&
		g_eMuleApp.m_pGlobPrefs->IsConfirmExitEnabled() &&
		( IDNO == MessageBox( GetResString(IDS_MAIN_EXIT), GetResString(IDS_MAIN_EXITTITLE),
		MB_YESNO | MB_DEFBUTTON2 ) ) )
	{
		return;
	}
// 	We should call this before changing the state to APP_STATE_SHUTINGDOWN because
// 	otherwise any log message inside this function (and there are few) will produce
// 	message box
#ifdef OLD_SOCKETS_ENABLED
	if (g_eMuleApp.m_pServerConnect->IsConnected())
		g_eMuleApp.m_pServerConnect->Disconnect();
#endif //OLD_SOCKETS_ENABLED

	g_eMuleApp.m_app_state = g_eMuleApp.APP_STATE_SHUTINGDOWN;

	g_eMuleApp.OnlineSig();
	g_eMuleApp.m_pDownloadQueue->SaveAllSLSFiles();

	WINDOWPLACEMENT wp;wp.length=sizeof(wp);GetWindowPlacement(&wp);
	g_eMuleApp.m_pGlobPrefs->SetWindowLayout(wp);

//	Disable redraws while shutting down, should take care of some crashes on exit
	m_wndTransfer.m_ctlDownloadList.SetRedraw(false);
	m_wndTransfer.m_ctlUploadList.SetRedraw(false);
	m_wndTransfer.m_ctlQueueList.SetRedraw(false);
	m_wndTransfer.m_ctlClientList.SetRedraw(false);
	m_dlgSearch.m_ctlSearchList.SetRedraw(false);
	m_wndSharedFiles.m_ctlSharedFilesList.SetRedraw(false);
	m_wndIRC.serverChannelList.SetRedraw(false);
	m_wndTransfer.m_ctlInfoList.SetRedraw(false);
	m_wndChat.m_FriendListCtrl.SetRedraw(false);
	m_wndChat.m_ctlChatSelector.SetRedraw(false);
	m_dlgStatistics.SetRedraw(false);
	m_wndTransfer.SetRedraw(false);
	m_dlgSearch.SetRedraw(false);
	m_wndSharedFiles.SetRedraw(false);
	m_wndIRC.SetRedraw(false);
	m_wndChat.SetRedraw(false);

	m_wndTransfer.m_ctlDownloadList.SaveSettings(CPreferences::TABLE_DOWNLOAD);
	m_wndTransfer.m_ctlUploadList.SaveSettings(CPreferences::TABLE_UPLOAD);
	m_wndTransfer.m_ctlQueueList.SaveSettings(CPreferences::TABLE_QUEUE);
	m_wndTransfer.m_ctlClientList.SaveSettings(CPreferences::TABLE_CLIENTLIST);
	m_dlgSearch.m_ctlSearchList.SaveSettings(CPreferences::TABLE_SEARCH);
	m_wndSharedFiles.m_ctlSharedFilesList.SaveSettings(CPreferences::TABLE_SHARED);
	m_wndServer.m_ctlServerList.SaveSettings(CPreferences::TABLE_SERVER);
	m_wndIRC.serverChannelList.SaveSettings(CPreferences::TABLE_IRC);
	m_wndChat.m_FriendListCtrl.SaveSettings(CPreferences::TABLE_FRIENDLIST);

//	Close preferences window if it is open, otherwise it can result in a crash
//	Such closure can be initiated for example by MobileMule shutdown request
	if (m_dlgPreferences.m_hWnd != NULL)
		m_dlgPreferences.PressButton(PSBTN_CANCEL);

	g_eMuleApp.m_pGlobPrefs->Add2TotalDownloaded(g_eMuleApp.stat_sessionReceivedBytes);
	g_eMuleApp.m_pGlobPrefs->Add2TotalUploaded(g_eMuleApp.stat_sessionSentBytes);
	g_eMuleApp.m_pGlobPrefs->SetDetailColumnWidth(m_wndTransfer.GetDetailColumnWidth());
	g_eMuleApp.m_pGlobPrefs->Save();

	g_eMuleApp.m_pdlgEmule->m_dlgSearch.SaveSearchStrings();

//	Restore old registry if required
	if (g_eMuleApp.m_pGlobPrefs->AutoTakeED2KLinks())
		RevertReg();

//	Remove all list items
	m_wndSharedFiles.m_ctlSharedFilesList.DeleteAllItems();
	m_wndTransfer.m_ctlClientList.DeleteAllItems();
	m_wndTransfer.m_ctlUploadList.DeleteAllItems();
	m_wndTransfer.m_ctlQueueList.DeleteAllItems();
	m_wndTransfer.m_ctlDownloadList.DeleteAllItems();
	m_wndChat.m_ctlChatSelector.DeleteAllItems();
	m_dlgSearch.m_ctlSearchList.DeleteAllItems();

	ShowWindow(SW_HIDE);

//	All dialog windows created should be destroyed
	m_wndServer.DestroyWindow();
	m_wndTransfer.DestroyWindow();
	m_dlgSearch.DestroyWindow();
	m_wndSharedFiles.DestroyWindow();
	m_wndIRC.DestroyWindow();
	m_wndChat.DestroyWindow();
	m_dlgStatistics.DestroyWindow();

	g_eMuleApp.m_pClientList->DeleteAll();

//	Moved here, should avoid crashes when closing & downloading.
	g_eMuleApp.m_pKnownFilesList->Save();

	delete g_eMuleApp.m_pFakeCheck;

	CTrayDialog::OnCancel();

//	Backup on exit
	if (g_eMuleApp.m_pGlobPrefs->IsAutoBackup())
	{
		g_eMuleApp.m_pdlgEmule->RunBackupNow(true);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnTrayRButtonUp(CPoint pt)
{
	EMULE_TRY

	if(m_pSystrayDlg)
	{
		m_pSystrayDlg->BringWindowToTop();
		return;
	}

	m_pSystrayDlg = new CMuleSystrayDlg(this, pt);
	if(m_pSystrayDlg)
	{
		UINT nResult = m_pSystrayDlg->DoModal();
		delete m_pSystrayDlg;
		m_pSystrayDlg = NULL;
		switch(nResult)
		{
			case IDC_TOMAX:
				QuickSpeedOther(MP_QS_UA);
				break;
			case IDC_TOMIN:
				QuickSpeedOther(MP_QS_PA);
				break;
			case IDC_RESTORE:
				RestoreWindow();
				break;
			case IDC_CONNECT:
				StartConnection();
				break;
			case IDC_DISCONNECT:
				CloseConnection();
				break;
			case IDC_EXIT:
				OnClose();
				break;
			case IDC_PREFERENCES:
			{
				static int iOpen = 0;
				if(!iOpen)
				{
					iOpen = 1;
					m_dlgPreferences.DoModal();
					iOpen = 0;
				}
				break;
			}
			default:
				break;
		}
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	StartConnection() initiates a connection attempt to a server.
void CEmuleDlg::StartConnection()
{
	EMULE_TRY

	AddLogLine(true, IDS_CONNECTING);
//	If there's more than one server selected in the server list...
	if (m_wndServer.m_ctlServerList.GetSelectedCount() > 1)
	{
		m_wndServer.m_ctlServerList.PostMessage(WM_COMMAND,MP_CONNECTTO,0L);
	}
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		g_eMuleApp.m_pServerConnect->ConnectToAnyServer();
#endif //OLD_SOCKETS_ENABLED
	}
	ShowConnectionState(false);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::CloseConnection()
{
	EMULE_TRY
	if (g_eMuleApp.m_pServerConnect->IsConnected())
	{
		if( !g_eMuleApp.m_pGlobPrefs->IsConfirmDisconnectEnabled() ||
			( MessageBox(GetResString(IDS_BACKUP_SURE), GetResString(IDS_IRC_DISCONNECT),
			MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2) == IDYES ) )
		{
#ifdef OLD_SOCKETS_ENABLED
			g_eMuleApp.m_pServerConnect->Disconnect();
#endif //OLD_SOCKETS_ENABLED
		}
	}
	else if (g_eMuleApp.m_pServerConnect->IsConnecting())
	{
#ifdef OLD_SOCKETS_ENABLED
		g_eMuleApp.m_pServerConnect->StopConnectionTry();
#endif //OLD_SOCKETS_ENABLED
	}
	g_eMuleApp.OnlineSig();

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::RestoreWindow()
{
	EMULE_TRY

	if (TrayIsVisible())
		TrayHide();
	ShowWindow(SW_SHOW);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowStatistics()
{
	m_dlgStatistics.ShowStatistics();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::UpdateTrayIcon(int procent)
{
	EMULE_TRY

//	Set the limits of where the bar color changes (low-high)
	int pLimits16[1] = {100};

// 	Set the corresponding color for each level
	COLORREF pColors16[1] = { RGB(1,255,1) };

//	Start it up
#ifdef OLD_SOCKETS_ENABLED
	if(g_eMuleApp.m_pServerConnect->IsConnected() && !g_eMuleApp.m_pServerConnect->IsLowID())
		m_trayMeterIcon.Init(m_hiconSourceTray,100,1,1,16,16, RGB(37,97,37));
	else if(g_eMuleApp.m_pServerConnect->IsConnected() && g_eMuleApp.m_pServerConnect->IsLowID())
		m_trayMeterIcon.Init(m_hiconSourceTrayLowID,100,1,1,16,16, RGB(37,97,37));
	else
#endif //OLD_SOCKETS_ENABLED
		m_trayMeterIcon.Init(m_hiconSourceTrayGrey,100,1,1,16,16, RGB(37,97,37));

//	Load our limit and color info
	m_trayMeterIcon.SetColorLevels(pLimits16,pColors16,1);

// 	Generate the icon (destroy these icons using DestroyIcon())
	int pVals16[1] = {procent};

	m_hiconMyTray = m_trayMeterIcon.Create(pVals16);
	ASSERT (m_hiconMyTray != NULL);
	if (m_hiconMyTray != NULL)
		TraySetIcon(m_hiconMyTray, true);
	TrayUpdate();

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CEmuleDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	EMULE_TRY

	return CTrayDialog::OnCreate(lpCreateStruct);

	EMULE_CATCH2

	return -1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// TaskbarNotifier
void CEmuleDlg::ShowNotifier(const CString &strText, int iMsgType, bool bForceSoundOFF, bool bMsgEnabled)
{
	EMULE_TRY

	if (bMsgEnabled && m_wndTaskbarNotifier.m_bStarted)
	{
		CString strTempMessage, strFinalMessage;
		int iPos = 0;

		for (;;)
		{
			strTempMessage = strText.Tokenize(_T(" "), iPos);
			if (strTempMessage.IsEmpty())
				break;
			int iStrLength = strTempMessage.GetLength();
			int iStrLineBreak = 30;

			while (iStrLength > 30)
			{
				strTempMessage.Insert(iStrLineBreak, " ");
				iStrLineBreak += 30;
				iStrLength -= 30;
			}

			strFinalMessage += strTempMessage;
			strFinalMessage += _T(' ');
		}

		strFinalMessage.Trim();

		m_wndTaskbarNotifier.Show(strFinalMessage, iMsgType, 500, g_eMuleApp.m_pGlobPrefs->NotificationDisplayTime());

		if (g_eMuleApp.m_pGlobPrefs->GetUseSoundInNotifier() && !bForceSoundOFF)
			PlaySound(g_eMuleApp.m_pGlobPrefs->GetNotifierWavSoundPath(), NULL, SND_FILENAME | SND_NOSTOP | SND_NOWAIT | SND_ASYNC);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnTaskbarNotifierClicked(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	int msgType = TBN_NULL;
	msgType = m_wndTaskbarNotifier.GetMessageType();
	switch(msgType)
	{
		case TBN_CHAT:
			RestoreWindow();
			SetActiveDialog(&m_wndChat);
			SetFocus();
			break;
		case TBN_DLOAD:
			RestoreWindow();
			SetActiveDialog(&m_wndTransfer);
			SetFocus();
			break;
		case TBN_DLOAD_ADD:
			RestoreWindow();
			SetActiveDialog(&m_wndTransfer);
			SetFocus();
			break;
		case TBN_IMPORTANTEVENT:
			RestoreWindow();
			SetActiveDialog(&m_wndServer);
			SetFocus();
			break;
		case TBN_LOG:
			RestoreWindow();
			SetActiveDialog(&m_wndServer);
			SetFocus();
			break;
	}
	return 0;

	EMULE_CATCH2

	return -1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::Localize()
{
	EMULE_TRY

	if(m_hWnd)
	{
		m_ctlToolBar.Localize();

		if (!m_ctlStatusBar)
			return;

#ifdef OLD_SOCKETS_ENABLED
		if(g_eMuleApp.m_pServerConnect->IsConnected())
		{
			CServer	*pCurServer = g_eMuleApp.m_pServerConnect->GetCurrentServer();

			ShowUserCount(pCurServer->GetNumUsers(), pCurServer->GetFiles());
		}
		else
		{
			m_ctlStatusBar.SetText(_T("0"), SB_NUMUSERS, 0);
			if(g_eMuleApp.m_pServerConnect->IsConnecting())
				m_ctlStatusBar.SetText(GetResString(IDS_CONNECTING),SB_SERVER,0);
			else
				m_ctlStatusBar.SetText(GetResString(IDS_NOTCONNECTED),SB_SERVER,0);
		}
#endif //OLD_SOCKETS_ENABLED
		ShowTransferRate(true);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	DisConnect() toggles the server connection on and off.
void CEmuleDlg::DisConnect()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pServerConnect->IsConnected())
	{
	//	Connect if not currently connected
		if (!g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			if (g_eMuleApp.m_pServerConnect->IsICCActive())
			{
			//	Internet Connection Check is active, cancel it
				g_eMuleApp.m_pServerConnect->Disconnect();
				ShowConnectionState(false);
			}
			else
				StartConnection();
		}
		else
		{
			g_eMuleApp.m_pServerConnect->StopConnectionTry();
			ShowConnectionState(false);
		}
	}
	else
#endif //OLD_SOCKETS_ENABLED
	{
	//	Disconnect if currently connected
		CloseConnection();
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::PreTranslateMessage(MSG* pMsg) 
{ 
	if (g_eMuleApp.m_pGlobPrefs->GetToolTipDelay() != 0)
		m_ttip.RelayEvent(pMsg);

	return CTrayDialog::PreTranslateMessage(pMsg);
} 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
BOOL CEmuleDlg::OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult) 
{ 
	NM_PPTOOLTIP_DISPLAY	*pNotify = (NM_PPTOOLTIP_DISPLAY*)pNMH;
	int						iControlId = CWnd::FromHandle(pNotify->ti->hWnd)->GetDlgCtrlID();
	CString					strInfo;

	if (iControlId == IDC_STATUSBAR)
	{
		CPoint		pt;

		::GetCursorPos(&pt);
		m_ctlStatusBar.ScreenToClient(&pt);
		switch (m_ctlStatusBar.GetPaneAtPosition(pt))
		{
			case SB_MESSAGETEXT:
			{
				CString		strLogText = g_eMuleApp.m_pdlgEmule->m_wndServer.m_pctlLogBox->GetToolTip();
				
				if (!strLogText.IsEmpty())
				{
					strInfo.Format(_T("<t=1><b>%s</b><br><hr=100%%><br>%s"), GetResString(IDS_SV_LOG), strLogText);
					pNotify->ti->hIcon = g_eMuleApp.m_pdlgEmule->m_wndServer.m_imageList.ExtractIcon(0);
				}
				break;
			}
			case SB_SESSIONTIME:
			{
				uint32		dwRunTimeSecs = static_cast<uint32>((::GetTickCount() - g_eMuleApp.stat_starttime) / 1000);

				CTimeSpan	runTime(static_cast<__time64_t>(dwRunTimeSecs));
				CString		strRuntime;
				unsigned	uiDays, uiHours, uiMinutes;

				uiHours = static_cast<unsigned>(runTime.GetHours());
				uiMinutes = static_cast<unsigned>(runTime.GetMinutes());
				uiDays = static_cast<unsigned>(runTime.GetDays());

				if (uiDays == 0)
				{
					strRuntime.Format(_T("%02u:%02u:%02u"), uiHours, uiMinutes, runTime.GetSeconds());
				}
				else
				{
					strRuntime.Format(_T("%u %s %02u:%02u"), uiDays, 
														   GetResString((uiDays == 1) ? IDS_LONGDAY : IDS_LONGDAYS),
														   uiHours,
														   uiMinutes );
				}

				strInfo.Format( _T("<t=1><b>%s</b><br><hr=100%%><br><b>%s:</b><t>%s"), GetResString(IDS_STATS_TIMESTATS),
																					   GetResString(IDS_STATS_RUNTIME),
																					   strRuntime );

				if (g_eMuleApp.stat_serverConnectTime > 0)
				{
					uint32 dwServerDurationSecs = static_cast<uint32>((::GetTickCount() - g_eMuleApp.stat_serverConnectTime) / 1000);
					CTimeSpan ServerDuration(static_cast<__time64_t>(dwServerDurationSecs));
					uiHours = static_cast<unsigned>(ServerDuration.GetHours());
					uiMinutes = static_cast<unsigned>(ServerDuration.GetMinutes());
					uiDays = static_cast<unsigned>(ServerDuration.GetDays());

					if (uiDays == 0)
					{
						strRuntime.Format(_T("%02u:%02u:%02u"), uiHours, uiMinutes, ServerDuration.GetSeconds());
					}
					else
					{
						strRuntime.Format(_T("%u %s %02u:%02u"), uiDays,
															   GetResString((uiDays == 1) ? IDS_LONGDAY : IDS_LONGDAYS),
															   uiHours,
															   uiMinutes );
					}

					strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s"),	GetResString(IDS_STATS_CURRSRVDUR), strRuntime);
				}

				pNotify->ti->hIcon = g_eMuleApp.m_pdlgEmule->m_dlgStatistics.m_imagelistStatTree.ExtractIcon(12);
				break;
			}
			case SB_NUMUSERS:
			{
				CServer *pServer = g_eMuleApp.m_pServerConnect != NULL ? g_eMuleApp.m_pServerConnect->GetCurrentServer() : NULL;

				if (pServer != NULL)
					pServer = g_eMuleApp.m_pServerList->GetServerByAddress(pServer->GetAddress(), pServer->GetPort());

				if (pServer == NULL)
					return FALSE;

				strInfo = pServer->GetUsersInfo4Tooltips();
 				pNotify->ti->hIcon = CopyIcon(m_hiconUsers);
				break;
			}
			case SB_UPLOADRATE:
			{
				double dblLastUprate_KB = static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRate())/1024.0;
				double dblLastUprateOverhead_KB = static_cast<double>(g_eMuleApp.m_pUploadQueue->GetUpDataRateOverhead())/1024.0;

				strInfo.Format( _T("<t=1><b>%s</b><br><hr=100%%><br><b>%s:</b><t>%.2f<br><b>%s:</b><t>%.2f<br><b>%s:</b><t>%s (%s)"),
								GetResString(IDS_TW_UPLOADS), GetResString(IDS_DL_SPEED), dblLastUprate_KB,
								GetResString(IDS_STATS_OVRHD), dblLastUprateOverhead_KB, GetResString(IDS_STATS_UDATA),
								CastItoXBytes(g_eMuleApp.stat_sessionSentBytes),
								CastItoXBytes(g_eMuleApp.stat_sessionSentBytes + g_eMuleApp.m_pGlobPrefs->GetTotalUploaded()) );
				pNotify->ti->hIcon = CopyIcon(m_hiconTrans[(dblLastUprate_KB != 0) ? 1:0]);
				break;
			}
			case SB_DOWNLOADRATE:
			{
				double dblLastDownrate_KB = static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate())/1024.0;
				double dblLastDownrateOverhead_KB = static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDownDataRateOverhead())/1024.0;

				strInfo.Format( _T("<t=1><b>%s</b><br><hr=100%%><br><b>%s:</b><t>%.2f<br><b>%s:</b><t>%.2f<br><b>%s:</b><t>%s (%s)"),
								GetResString(IDS_TW_DOWNLOADS), GetResString(IDS_DL_SPEED), dblLastDownrate_KB,
								GetResString(IDS_STATS_OVRHD), dblLastDownrateOverhead_KB, GetResString(IDS_STATS_DDATA),
								CastItoXBytes(g_eMuleApp.stat_sessionReceivedBytes),
								CastItoXBytes( g_eMuleApp.stat_sessionReceivedBytes+g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded()) );
				pNotify->ti->hIcon = CopyIcon(m_hiconTrans[(dblLastDownrate_KB != 0) ? 3:2]);
				break;
			}
			case SB_SERVER:
			{
				CServer *pServer = g_eMuleApp.m_pServerConnect != NULL ? g_eMuleApp.m_pServerConnect->GetCurrentServer() : NULL;

				if (pServer != NULL)
					pServer = g_eMuleApp.m_pServerList->GetServerByAddress(pServer->GetAddress(), pServer->GetPort());

				if (pServer == NULL)
					return FALSE;

				pNotify->ti->hIcon = pServer->GetServerInfo4Tooltips(strInfo);
				break;
			}
		}
	}
	pNotify->ti->sTooltip = strInfo;

	return TRUE;
} 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
BOOL CEmuleDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	switch (wParam)
	{
		case IDC_TOOLBARBUTTON + MTB_CONNECT:
			DisConnect();
			break;
		case IDC_TOOLBARBUTTON + MTB_SERVERS:
			SetActiveDialog(&m_wndServer);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_TRANSFER:
			SetActiveDialog(&m_wndTransfer);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_SEARCH:
			SetActiveDialog(&m_dlgSearch);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_SHAREDFILES:
			SetActiveDialog(&m_wndSharedFiles);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_MESSAGES:
			SetActiveDialog(&m_wndChat);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_IRC:
			SetActiveDialog(&m_wndIRC);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_STATISTICS:
			SetActiveDialog(&m_dlgStatistics);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_PREFS:
			m_ctlToolBar.PressButton(wParam,TRUE);
			m_dlgPreferences.DoModal();
			m_ctlToolBar.PressButton(wParam,FALSE);
			break;
		default:
			break;
	}

	return CTrayDialog::OnCommand(wParam, lParam);

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::QuickSpeedOther(UINT nID)
{
	EMULE_TRY

	switch (nID)
	{
		case MP_QS_PA:
			g_eMuleApp.m_pGlobPrefs->SetMaxUpload(10);
			g_eMuleApp.m_pGlobPrefs->SetMaxDownload(10);
			break;
		case MP_QS_UA:
			g_eMuleApp.m_pGlobPrefs->SetMaxUpload(g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate());
			g_eMuleApp.m_pGlobPrefs->SetMaxDownload(g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate());
			break;
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::OnQueryEndSession()
{
	EMULE_TRY

	if (!CTrayDialog::OnQueryEndSession())
		return FALSE;

	if ( g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_DONE )
	{
		return TRUE;
	}
	else if ( g_eMuleApp.m_app_state   ==   g_eMuleApp.APP_STATE_RUNNING)
   	{
		g_eMuleApp.m_app_state = g_eMuleApp.APP_STATE_SHUTINGDOWN;
		CDialog::OnCancel();
		return TRUE;
   	}

	EMULE_CATCH2

   	return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerConnect(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pServerConnect->ConnectToServer(*(CServer*)wParam);
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerRemove(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RemoveServer((CServer*)wParam);

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerAddToStatic(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.StaticServerFileAppend((CServer*)wParam);
	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerRemoveFromStatic(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.StaticServerFileRemove((CServer*)wParam);

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerClearCompleted(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	if(!wParam)
	{
		EnumCategories eCatID = static_cast<_EnumCategories>(lParam);
		g_eMuleApp.m_pDownloadList->ClearCompleted(eCatID);
	}
	else
	{
		uchar* pFileHash = reinterpret_cast<uchar*>(lParam);
		g_eMuleApp.m_pDownloadList->ClearCompleted(pFileHash);
		delete[] pFileHash;
	}

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerFileRename(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	CString sNewName = ((LPCTSTR)(lParam));

	((CPartFile*)wParam)->SetFileName(sNewName);
	((CPartFile*)wParam)->SavePartFile();
	((CPartFile*)wParam)->UpdateDisplayedInfo();
	g_eMuleApp.m_pSharedFilesList->UpdateItem((CKnownFile*)((CPartFile*)wParam));
	g_eMuleApp.m_pdlgEmule->m_wndTransfer.UpdateInfoHeader();

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnProcessTaskUI(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

#ifdef NEW_SOCKETS
/*	CTask *pTask = (CTask*)wParam;
	if(pTask)
	{
		if(pTask->ProcessForUI(*g_eMuleApp.m_pEngine))
			delete pTask;
	}*/
#endif //NEW_SOCKETS

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebSharedFilesReload(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pSharedFilesList->Reload();

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// To find out if app is running or shutting/shut down
bool CEmuleDlg::IsRunning()
{
	return (g_eMuleApp.m_app_state == CEmuleApp::APP_STATE_RUNNING);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnNcDestroy()
{
	//see KB138681 [TwoBottle Mod]
	AfxGetApp()->m_pMainWnd = NULL;
	CTrayDialog::OnNcDestroy();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::TrayShow(void)
{
//	Set tray icon
	int DownRateProcent = (int)ceil(lastdownrate / 1.024 / g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate());
	if (DownRateProcent>100)
		DownRateProcent=100;

	UpdateTrayIcon(DownRateProcent);

	return CTrayDialog::TrayShow();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::RunBackupNow(bool automated)
{
	if (g_eMuleApp.m_pGlobPrefs->GetBackupDatFiles())
		BackupFromAppDir(_T("*.dat"), automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupMetFiles())
		BackupFromAppDir(_T("*.met"), automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupIniFiles())
		BackupFromAppDir(_T("*.ini"), automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupPartMetFiles())
		BackupFromTempDir(_T("*.part.met"), automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupPartTxtsrcFiles())
		BackupFromTempDir(_T("*.part.txtsrc"), automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupPartFiles())
	{
		if (automated ||
			::MessageBox(m_dlgPreferences.m_hWnd, GetResString(IDS_BACKUP_LONGTIME), GetResString(IDS_BACKUP_SURE), MB_ICONQUESTION|MB_YESNO) == IDYES)
		{
			BackupFromTempDir("*.part", automated);
		}
	}
	if (!automated)
		::MessageBox(m_dlgPreferences.m_hWnd, GetResString(IDS_BACKUP_SUCCESS), GetResString(IDS_BACKUP_COMPLETE), MB_OK);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::BackupFromAppDir(LPCSTR extensionToBack,bool automated)
{
	CString	strBuffer = g_eMuleApp.m_pGlobPrefs->GetBackupDir();

	strBuffer += _T('\\');

//	Create all required directories
	CreateAllDirectories(&strBuffer);
//	Copying files
	BackupFiles(extensionToBack, automated, g_eMuleApp.m_pGlobPrefs->GetConfigDir(), strBuffer);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::BackupFromTempDir(LPCSTR extensionToBack, bool automated)
{
	CString	strBuffer;

	strBuffer.Format(_T("%s\\Temp\\"), g_eMuleApp.m_pGlobPrefs->GetBackupDir());

//	Create all required directories
	CreateAllDirectories(&strBuffer);

	BackupFiles(extensionToBack, automated, g_eMuleApp.m_pGlobPrefs->GetTempDir(), strBuffer);

//	Additional Temp dirs backup
	int iTempDir = 1;

	CStringList	tmpTempDirList;	//	list elements will be deleted in list destructor

//	Make local copy to prevent long locking of list resource
	g_eMuleApp.m_pGlobPrefs->TempDirListCopy(&tmpTempDirList);

	for (POSITION pos = tmpTempDirList.GetHeadPosition(); pos != NULL; )
	{
		CString strSearchPath(tmpTempDirList.GetNext(pos));

		strBuffer.Format(_T("%s\\Temp[%i]\\"),g_eMuleApp.m_pGlobPrefs->GetBackupDir(),iTempDir);

	//	Create last directory. No need to use CreateAllDirectories() as the previous path already exists
		::CreateDirectory(strBuffer, NULL);

		BackupFiles(extensionToBack, automated, strSearchPath, strBuffer);

		char tempLog[1060];

		strBuffer += _T("backup.log");
		sprintf(tempLog, "Backed-up directory: %s",strSearchPath);
		FILE* LogFile = _tfopen(strBuffer, _T("w+"));
		if (LogFile != NULL)
	 	{
 			fwrite(tempLog, sizeof(char), strlen(tempLog), LogFile);
 			fclose(LogFile);
	 	}

		iTempDir++;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::BackupFiles(LPCSTR extensionToBack, bool automated, const CString &strPath, const CString &strBackupPath)
{
	WIN32_FIND_DATA fileData;
	HANDLE hSearch;
	BOOL fFinished = FALSE;
	BOOL finderror = FALSE;
	BOOL error = FALSE;
	BOOL overWrite = TRUE;
	char buffer[200];
	char szNewPath[MAX_PATH];
	CString	strDstPath = strPath;

//	Start searching for files in the directory.
	if (strDstPath.Right(1) != _T('\\'))
		strDstPath += _T('\\');

	CString	strTmp = strDstPath;

	strTmp += extensionToBack;
	hSearch = FindFirstFile(strTmp, &fileData);

	if (hSearch == INVALID_HANDLE_VALUE)
	{
		finderror = TRUE;
	}

//	Copy each file to the backup directory
	while (!fFinished && !finderror)
	{
		lstrcpy(szNewPath, strBackupPath);
		lstrcat(szNewPath,fileData.cFileName);

		if (PathFileExists(szNewPath))
		{
			if (!automated)
			{
				if (!g_eMuleApp.m_pGlobPrefs->GetBackupOverwrite())
				{
					sprintf(buffer,GetResString(IDS_BACKUP_EXIST),fileData.cFileName);
					if (MessageBox(buffer,GetResString(IDS_BACKUP_OVER),MB_ICONQUESTION|MB_YESNO)== IDYES)
						overWrite = TRUE;
					else
						overWrite = FALSE;
				}
			}
			else
			{
				overWrite = TRUE;
			}
		}
		if (overWrite)
		{
			strTmp = strDstPath;
			strTmp += fileData.cFileName;
			CopyFile(strTmp, szNewPath, FALSE);
		}
		if (!automated)
			AddDebugLogLine(_T("Backup %s done"), szNewPath);

		if (!FindNextFile(hSearch, &fileData))
		{
			if (GetLastError() == ERROR_NO_MORE_FILES)
			{
				fFinished = TRUE;
			}
			else
			{
				error = TRUE;
			}
		}

	}
//	Close the search handle.
	FindClose(hSearch);

	if (error)
	{
		AddDebugLogLine(RGB_LOG_ERROR_TXT _T("Error encountered during backup!"));
		if(!automated)
			MessageBox(GetResString(IDS_BACKUP_ERROR), GetResString(IDS_BACKUP_ERROR2), MB_OK);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::DisableAutoBackup()
{
	if (g_eMuleApp.m_pGlobPrefs->IsAutoBackup() || g_eMuleApp.m_pGlobPrefs->IsScheduledBackup())
	{
		g_eMuleApp.m_pGlobPrefs->SetScheduledBackup(false);
		g_eMuleApp.m_pGlobPrefs->SetAutoBackup(false);

		AddLogLine(false, RGB_LOG_WARNING + GetResString(IDS_AUTOBACKUP_DISABLED));
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	PostUniqueMessage() check the existence of message in the list control's message queue & puts it into the queue if message does not exist
void CEmuleDlg::PostUniqueMessage(UINT uiMsg)
{
	if (::IsWindow(GetSafeHwnd()) && g_eMuleApp.m_app_state != CEmuleApp::APP_STATE_SHUTINGDOWN)
	{
		MSG		msg;

	//	If there's no refresh message already in the message queue... (don't want to flood it)
		if (!::PeekMessage(&msg, m_hWnd, uiMsg, uiMsg, PM_NOREMOVE))
		{
			PostMessage(uiMsg, 0, 0);
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString* CEmuleDlg::GetNewLogTextLines()
{
	CString		*pstrNewLines = NULL;

	if (!m_pstrNewLogTextLines->IsEmpty())
	{
		pstrNewLines = m_pstrNewLogTextLines;
		m_pstrNewLogTextLines = new CString;
	}

	return pstrNewLines;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString* CEmuleDlg::GetNewDebugLogTextLines()
{
	CString		*pstrNewLines = NULL;

	if (!m_pstrNewDebugLogTextLines->IsEmpty())
	{
		pstrNewLines = m_pstrNewDebugLogTextLines;
		m_pstrNewDebugLogTextLines = new CString;
	}

	return pstrNewLines;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::OnWndMsg(UINT iMessage,WPARAM wParam, LPARAM lParam, LRESULT *pResult)
{
	BOOL		bHandled = TRUE;

	EMULE_TRY

	switch (iMessage)
	{
		case WM_LOG_REFRESH:
		{
			const CString	   *pstrNewLines = GetNewLogTextLines();

			if (pstrNewLines != NULL)
			{
				OutputLogText(*pstrNewLines, m_wndServer.m_pctlLogBox);
				if (m_wndServer.m_ctrlBoxSwitcher.GetCurSel() != 0)
					m_wndServer.m_ctrlBoxSwitcher.SetItemState(0, TCIS_HIGHLIGHTED, TCIS_HIGHLIGHTED);

				delete pstrNewLines;
			}
			break;
		}

		case WM_DLOG_REFRESH:
		{
			const CString	   *pstrNewLines = GetNewDebugLogTextLines();

			if (pstrNewLines != NULL)
			{
				OutputLogText(*pstrNewLines, m_wndServer.m_pctlDebugBox);
				if (m_wndServer.m_ctrlBoxSwitcher.GetCurSel() != 2)
					m_wndServer.m_ctrlBoxSwitcher.SetItemState(2, TCIS_HIGHLIGHTED, TCIS_HIGHLIGHTED);

				delete pstrNewLines;
			}
			break;
		}
		default:
			bHandled = FALSE;
			break;
	}

	EMULE_CATCH

	if (!bHandled)
		bHandled = CDialog::OnWndMsg(iMessage, wParam, lParam, pResult);

	return bHandled;
}
